com.verisign.epp.codec.idntable

## Class EPPIdnTableInfoTable

- java.lang.Object
- - com.verisign.epp.codec.idntable.EPPIdnTableInfoTable

- All Implemented Interfaces:
    EPPCodecComponent, java.io.Serializable, java.lang.Cloneable

      public class EPPIdnTableInfoTable
      extends java.lang.Object
      implements EPPCodecComponent

  `EPPIdnTableInfoTable` is used to represent the Internationalized Domain Name (IDN) table information for an IDN Table in a Table Info Form response.
  See Also:
    Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `EPPIdnTableInfoTable.Type` Table types, that include: `LANGUAGE` that represents a Language IDN Table. `SCRIPT` that represents a Script IDN Table.

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.String` | `ELM_LOCALNAME` XML local name for `EPPIdnTableInfoTable`.
    `static java.lang.String` | `ELM_NAME` XML root tag for `EPPIdnTableInfoTable`.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `EPPIdnTableInfoTable()` Default constructor for `EPPIdnTableInfoTable`.
    `EPPIdnTableInfoTable(java.lang.String aName, EPPIdnTableInfoTable.Type aType, java.lang.String aDescription, java.util.Date aUpdateDate)` Constructor for `EPPIdnTableInfoTable` that takes the required attributes.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.Object` | `clone()` clone an `EPPCodecComponent`.
    `void` | `decode(org.w3c.dom.Element aElement)` decode a DOM element tree to initialize the instance attributes.
    `org.w3c.dom.Element` | `encode(org.w3c.dom.Document aDocument)` encode instance into a DOM element tree.
    `boolean` | `equals(java.lang.Object aObject)` Compare an instance of `EPPIdnTableInfoTable` with this instance.
    `java.lang.String` | `getDescription()` Gets the server defined description of the IDN Table.
    `java.lang.String` | `getDescriptionLang()` Gets the language of the description of the IDN Table with the default value of "en".
    `java.util.Date` | `getEffectiveDate()` Gets the OPTIONAL effective date of the IDN Table.
    `java.lang.String` | `getName()` Gets the IDN Table identifier.
    `java.lang.String` | `getNamespace()` Returns the XML namespace associated with the `EPPCodecComponent`.
    `EPPIdnTableInfoTable.Type` | `getType()` Gets the IDN Table type
    `java.util.Date` | `getUpdateDate()` Gets the date and time that the IDN Table was created or last updated.
    `java.lang.String` | `getUrl()` Gets the OPTIONAL URL for downloading the IDN Table with the applicable set of code points and rules.
    `java.lang.Boolean` | `getVariantGen()` Gets the OPTIONAL boolean flag indicating that domains created using the IDN Table will have IDN variants generated.
    `java.lang.String` | `getVersion()` Gets the OPTIONAL server defined version number of the IDN Table.
    `boolean` | `hasDescriptionLang()` Is the description language defined?
    `boolean` | `hasEffectiveDate()` Is the effective date defined?
    `boolean` | `hasUrl()` Is the URL defined?
    `boolean` | `hasVariantGen()` Is the variant generation flag defined?
    `boolean` | `hasVersion()` Is the version defined?
    `void` | `setDescription(java.lang.String aDescription)` Sets the server defined description of the IDN Table.
    `void` | `setDescriptionLang(java.lang.String aDescriptionLang)` Sets the language of the description of the IDN Table.
    `void` | `setEffectiveDate(java.util.Date aEffectiveDate)` Sets the OPTIONAL effective date of the IDN Table.
    `void` | `setName(java.lang.String aName)` Sets the IDN Table identifier.
    `void` | `setType(EPPIdnTableInfoTable.Type aType)` Sets the IDN Table type.
    `void` | `setUpdateDate(java.util.Date aUpdateDate)` Sets the date and time that the IDN Table was created or last updated.
    `void` | `setUrl(java.lang.String aUrl)` Sets the OPTIONAL URL for downloading the IDN Table with the applicable set of code points and rules.
    `void` | `setVariantGen(java.lang.Boolean aVariantGen)` Sets the OPTIONAL boolean flag indicating that domains created using the IDN Table will have IDN variants generated.
    `void` | `setVersion(java.lang.String aVersion)` Sets the OPTIONAL server defined version number of the IDN Table.
    `java.lang.String` | `toString()` Implementation of `Object.toString`, which will result in an indented XML `String` representation of the concrete `EPPCodecComponent`.

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### ELM_LOCALNAME

          public static final java.lang.String ELM_LOCALNAME

      XML local name for `EPPIdnTableInfoTable`.
      See Also:
        Constant Field Values

    - #### ELM_NAME

          public static final java.lang.String ELM_NAME

      XML root tag for `EPPIdnTableInfoTable`.
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### EPPIdnTableInfoTable

          public EPPIdnTableInfoTable()

      Default constructor for `EPPIdnTableInfoTable`.

    - #### EPPIdnTableInfoTable

          public EPPIdnTableInfoTable(java.lang.String aName,
                                      EPPIdnTableInfoTable.Type aType,
                                      java.lang.String aDescription,
                                      java.util.Date aUpdateDate)

      Constructor for `EPPIdnTableInfoTable` that takes the required attributes.
      Parameters:
        `aName` - Table identifier
        `aType` - IDN Table type
        `aDescription` - Server defined description of the IDN Table.
        `aUpdateDate` - Date and time the IDN Table was created or last updated.

  - ### Method Detail

    - #### getName

          public java.lang.String getName()

      Gets the IDN Table identifier.
      Returns:
        The IDN Table identifier

    - #### setName

          public void setName(java.lang.String aName)

      Sets the IDN Table identifier.
      Parameters:
        `aName` - The IDN Table identifier.

    - #### getType

          public EPPIdnTableInfoTable.Type getType()

      Gets the IDN Table type
      Returns:
        Type of the IDN table

    - #### setType

          public void setType(EPPIdnTableInfoTable.Type aType)

      Sets the IDN Table type.
      Parameters:
        `aType` - IDN type

    - #### getDescription

          public java.lang.String getDescription()

      Gets the server defined description of the IDN Table.
      Returns:
        The server defined description of the IDN Table.

    - #### setDescription

          public void setDescription(java.lang.String aDescription)

      Sets the server defined description of the IDN Table.
      Parameters:
        `aDescription` - The server defined description of the IDN Table.

    - #### hasDescriptionLang

          public boolean hasDescriptionLang()

      Is the description language defined?
      Returns:
        `true` if the description language is defined; `false` otherwise.

    - #### getDescriptionLang

          public java.lang.String getDescriptionLang()

      Gets the language of the description of the IDN Table with the default value of "en".
      Returns:
        The language of the description.

    - #### setDescriptionLang

          public void setDescriptionLang(java.lang.String aDescriptionLang)

      Sets the language of the description of the IDN Table.
      Parameters:
        `aDescriptionLang` - The language of the description.

    - #### getUpdateDate

          public java.util.Date getUpdateDate()

      Gets the date and time that the IDN Table was created or last updated.
      Returns:
        Date and time the IDN Table was created or last updated.

    - #### setUpdateDate

          public void setUpdateDate(java.util.Date aUpdateDate)

      Sets the date and time that the IDN Table was created or last updated.
      Parameters:
        `aUpdateDate` - Date and time the IDN Table was created or last updated.

    - #### hasVersion

          public boolean hasVersion()

      Is the version defined?
      Returns:
        `true` if the version is defined; `false` otherwise.

    - #### getVersion

          public java.lang.String getVersion()

      Gets the OPTIONAL server defined version number of the IDN Table.
      Returns:
        Server defined version of of the IDN Table if defined; `null` otherwise.

    - #### setVersion

          public void setVersion(java.lang.String aVersion)

      Sets the OPTIONAL server defined version number of the IDN Table.
      Parameters:
        `aVersion` - Server defined version of of the IDN Table. Set to `null` to clear the attribute.

    - #### hasEffectiveDate

          public boolean hasEffectiveDate()

      Is the effective date defined?
      Returns:
        `true` if the effective date is defined; `false` otherwise.

    - #### getEffectiveDate

          public java.util.Date getEffectiveDate()

      Gets the OPTIONAL effective date of the IDN Table.
      Returns:
        The effective date of the IDN Table if defined; `null` otherwise.

    - #### setEffectiveDate

          public void setEffectiveDate(java.util.Date aEffectiveDate)

      Sets the OPTIONAL effective date of the IDN Table.
      Parameters:
        `aEffectiveDate` - The effective date of the IDN Table. Set to `null` to clear the attribute.

    - #### hasVariantGen

          public boolean hasVariantGen()

      Is the variant generation flag defined?
      Returns:
        `true` if the variant generation flag is defined; `false` otherwise.

    - #### getVariantGen

          public java.lang.Boolean getVariantGen()

      Gets the OPTIONAL boolean flag indicating that domains created using the IDN Table will have IDN variants generated.
      Returns:
        `true` or `false` indicating that the domains created using the IDN Table will have IDN variants generated if defined; `null` otherwise.

    - #### setVariantGen

          public void setVariantGen(java.lang.Boolean aVariantGen)

      Sets the OPTIONAL boolean flag indicating that domains created using the IDN Table will have IDN variants generated.
      Parameters:
        `aVariantGen` - Non-`null` value indicating that the domains created using the IDN Table will have IDN variants generated. Use `null` to clear the flag.

    - #### hasUrl

          public boolean hasUrl()

      Is the URL defined?
      Returns:
        `true` if the URL is defined; `false` otherwise.

    - #### getUrl

          public java.lang.String getUrl()

      Gets the OPTIONAL URL for downloading the IDN Table with the applicable set of code points and rules.
      Returns:
        The URL for downloading the IDN Table with the applicable set of code points and rules if defined; `null` otherwise.

    - #### setUrl

          public void setUrl(java.lang.String aUrl)

      Sets the OPTIONAL URL for downloading the IDN Table with the applicable set of code points and rules.
      Parameters:
        `aUrl` - The URL for downloading the IDN Table with the applicable set of code points and rules. Set to `null` to clear the attribute.

    - #### encode

          public org.w3c.dom.Element encode(org.w3c.dom.Document aDocument)
                                     throws EPPEncodeException

      encode instance into a DOM element tree. A DOM Document is passed as an argument and functions as a factory for DOM objects. The root element associated with the instance is created and each instance attribute is appended as a child node.
      Specified by:
        `encode` in interface `EPPCodecComponent`
      Parameters:
        `aDocument` - DOM Document, which acts is an Element factory
      Returns:
        Element Root element associated with the object
      Throws:
        `EPPEncodeException` - Error encoding `EPPIdnTableInfoTable`

    - #### decode

          public void decode(org.w3c.dom.Element aElement)
                      throws EPPDecodeException

      decode a DOM element tree to initialize the instance attributes. The `aElement` argument represents the root DOM element and is used to traverse the DOM nodes for instance attribute values.
      Specified by:
        `decode` in interface `EPPCodecComponent`
      Parameters:
        `aElement` - `Element` to decode
      Throws:
        `EPPDecodeException` - Error decoding `Element`

    - #### clone

          public java.lang.Object clone()
                                 throws java.lang.CloneNotSupportedException

      clone an `EPPCodecComponent`.
      Specified by:
        `clone` in interface `EPPCodecComponent`
      Overrides:
        `clone` in class `java.lang.Object`
      Returns:
        clone of concrete `EPPIdnTableInfoTable`
      Throws:
        `java.lang.CloneNotSupportedException` - standard Object.clone exception

    - #### toString

          public java.lang.String toString()

      Implementation of `Object.toString`, which will result in an indented XML `String` representation of the concrete `EPPCodecComponent`.
      Overrides:
        `toString` in class `java.lang.Object`
      Returns:
        Indented XML `String` if successful; `ERROR` otherwise.

    - #### equals

          public boolean equals(java.lang.Object aObject)

      Compare an instance of `EPPIdnTableInfoTable` with this instance.
      Overrides:
        `equals` in class `java.lang.Object`
      Parameters:
        `aObject` - Object to compare with.
      Returns:
        `true` if equal; `false` otherwise.

    - #### getNamespace

          public java.lang.String getNamespace()

      Returns the XML namespace associated with the `EPPCodecComponent`.
      Specified by:
        `getNamespace` in interface `EPPCodecComponent`
      Returns:
        XML namespace for the `EPPCodecComponent`.